searchNodes=[{"doc":"Contains basic functions for similarity calculation. Similarity.Cosine - easy cosine similarity calculation Similarity.Simhash - simhash similarity calculation between two strings","ref":"Similarity.html","title":"Similarity","type":"module"},{"doc":"Calculates Cosine similarity between two vectors. https://en.wikipedia.org/wiki/Cosine_similarity#Definition Example: Similarity . cosine ( [ 1 , 2 , 3 ] , [ 1 , 2 , 8 ] )","ref":"Similarity.html#cosine/2","title":"Similarity.cosine/2","type":"function"},{"doc":"Multiplies cosine similarity with the square root of compared vectors length. srol = square root of length This gives better comparable numbers in real life where the number of attributes compared might differ. Use this if the number of shared attributes between real world objects differ. Example: Similarity . cosine_srol ( [ 1 , 2 , 3 ] , [ 1 , 2 , 8 ] )","ref":"Similarity.html#cosine_srol/2","title":"Similarity.cosine_srol/2","type":"function"},{"doc":"Calculates Euclidean dot product of two vectors. https://en.wikipedia.org/wiki/Euclidean_vector#Dot_product Example: iex&gt; Similarity . dot_product ( [ 1 , 2 ] , [ 3 , 4 ] ) 11","ref":"Similarity.html#dot_product/3","title":"Similarity.dot_product/3","type":"function"},{"doc":"Calculates Euclidean magnitude of one vector. https://en.wikipedia.org/wiki/Magnitude_(mathematics)#Euclidean_vector_space Example: iex&gt; Similarity . magnitude ( [ 2 ] ) 2.0","ref":"Similarity.html#magnitude/2","title":"Similarity.magnitude/2","type":"function"},{"doc":"See Similarity.Simhash.similarity/3 .","ref":"Similarity.html#simhash/3","title":"Similarity.simhash/3","type":"function"},{"doc":"A struct that can be used to accumulate ids &amp; attributes and calcuate similarity between them.","ref":"Similarity.Cosine.html","title":"Similarity.Cosine","type":"module"},{"doc":"Puts a new id with attributes into %Cosine{}.map and returns %Cosine{} struct. Example: s = Similarity.Cosine . new s = s |&gt; Similarity.Cosine . add ( &quot;barna&quot; , [ { &quot;n_of_bacons&quot; , 3 } , { &quot;hair_color_r&quot; , 124 } , { &quot;hair_color_g&quot; , 188 } , { &quot;hair_color_b&quot; , 11 } ] )","ref":"Similarity.Cosine.html#add/3","title":"Similarity.Cosine.add/3","type":"function"},{"doc":"Returns Similarity.cosine_srol/2 similarity between two pairs of ids (id_a, id_b) in %Cosine{} Example: s = Similarity.Cosine . new s = s |&gt; Similarity.Cosine . add ( &quot;barna&quot; , [ { &quot;n_of_bacons&quot; , 3 } , { &quot;hair_color_r&quot; , 124 } , { &quot;hair_color_g&quot; , 188 } , { &quot;hair_color_b&quot; , 11 } ] ) s = s |&gt; Similarity.Cosine . add ( &quot;somebody&quot; , [ { &quot;n_of_bacons&quot; , 0 } , { &quot;hair_color_r&quot; , 222 } , { &quot;hair_color_g&quot; , 62 } , { &quot;hair_color_b&quot; , 11 } ] ) s |&gt; Similarity.Cosine . between ( &quot;barna&quot; , &quot;somebody&quot; )","ref":"Similarity.Cosine.html#between/3","title":"Similarity.Cosine.between/3","type":"function"},{"doc":"Returns a new %Cosine{} struct to be first used with add/3 function","ref":"Similarity.Cosine.html#new/0","title":"Similarity.Cosine.new/0","type":"function"},{"doc":"Returns a stream of all unique pairs of similarities in %Cosine{}.map Example: s = Similarity.Cosine . new s = s |&gt; Similarity.Cosine . add ( &quot;barna&quot; , [ { &quot;n_of_bacons&quot; , 3 } , { &quot;hair_color_r&quot; , 124 } , { &quot;hair_color_g&quot; , 188 } , { &quot;hair_color_b&quot; , 11 } ] ) s = s |&gt; Similarity.Cosine . add ( &quot;somebody&quot; , [ { &quot;n_of_bacons&quot; , 0 } , { &quot;hair_color_r&quot; , 222 } , { &quot;hair_color_g&quot; , 62 } , { &quot;hair_color_b&quot; , 11 } ] ) Similarity.Cosine . stream ( s )","ref":"Similarity.Cosine.html#stream/1","title":"Similarity.Cosine.stream/1","type":"function"},{"doc":"Simhash string similarity algorithm. Description of Simhash iex&gt; Similarity . simhash ( &quot;Barna&quot; , &quot;Kovacs&quot; ) 0.59375 iex&gt; Similarity . simhash ( &quot;Austria&quot; , &quot;Australia&quot; ) 0.65625","ref":"Similarity.Simhash.html","title":"Similarity.Simhash","type":"module"},{"doc":"Returns Hamming distance between the left and right hash, given as lists of bits. Examples iex&gt; Similarity.Simhash . hamming_distance ( [ 1 , 1 , 0 , 1 , 0 ] , [ 0 , 1 , 1 , 1 , 0 ] ) 2","ref":"Similarity.Simhash.html#hamming_distance/3","title":"Similarity.Simhash.hamming_distance/3","type":"function"},{"doc":"Returns the hash for the given string in the given return_type . Examples Similarity.Simhash . hash ( &quot;alma korte&quot; , 3 ) [ 1 , 1 , 0 , 1 , 0 , 0 , 0 , 0 , 0 , 1 , 0 , 1 , ... ] Similarity.Simhash . hash ( &quot;alma korte&quot; , 3 , :list ) [ 1 , 1 , 0 , 1 , 0 , 0 , 0 , 0 , 0 , 1 , 0 , 1 , ... ] Similarity.Simhash . hash ( &quot;alma korte&quot; , 3 , :integer ) 15012197954348909067","ref":"Similarity.Simhash.html#hash/3","title":"Similarity.Simhash.hash/3","type":"function"},{"doc":"Calculates the similarity between the left and right string, using Simhash. Returns a float representing similarity between left and right strings. Options :ngram_size - defaults to 3 Examples iex&gt; Similarity . simhash ( &quot;khan academy&quot; , &quot;khan academia&quot; ) 0.890625 iex&gt; Similarity . simhash ( &quot;khan academy&quot; , &quot;academy khan&quot; , ngram_size : 1 ) 1.0","ref":"Similarity.Simhash.html#similarity/3","title":"Similarity.Simhash.similarity/3","type":"function"}]